import { ContextValue, ScriptContext, SyntaxNode } from '../common';
import { OperatorNode } from './common';
export declare type CompiledExpression = Readonly<{
    buffer: SyntaxNode[];
    operatorNodes: OperatorNode[];
}>;
export declare const compileExpression: (buffer: SyntaxNode[], context: ScriptContext) => CompiledExpression;
export declare const evalCompiledExpression: (compiledExpression: CompiledExpression, context: ScriptContext, copyBuffers: boolean, optimizeOperators: boolean) => ContextValue;
/**
 * Evalute an expression.
 */
export declare const evalExpression: (nodes: readonly SyntaxNode[], context: ScriptContext, begin?: number, end?: number) => ContextValue;
