import { ContextValue, ScriptContext, SyntaxNode } from '../common';
import { CompiledExpression } from './evalExpression';
export declare type CompiledNodes = Readonly<{
    compiledExpressions: readonly CompiledExpression[];
    endsWithSemicolon: boolean;
}>;
export declare const compileNodes: (nodes: readonly SyntaxNode[], context: ScriptContext, begin?: number, end?: number) => CompiledNodes;
export declare const evalCompiledNodes: (compiledNodes: CompiledNodes, context: ScriptContext, copyBuffers: boolean, optimizeOperators: boolean) => ContextValue;
/**
 * Evaluate the given nodes.
 */
export declare const evalNodes: (nodes: readonly SyntaxNode[], context: ScriptContext, begin?: number, end?: number) => ContextValue;
